/* HotCorner.c generated by valac 0.56.14, the Vala compiler
 * generated from HotCorner.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc (https://elementary.io)
 *           2021 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <meta/barrier.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <meta/display.h>
#include <stdlib.h>
#include <string.h>
#include <mtk/mtk.h>
#include <clutter/clutter.h>

#define GALA_HOT_CORNER_POSITION_TOP_LEFT "hotcorner-topleft"
#define GALA_HOT_CORNER_POSITION_TOP_RIGHT "hotcorner-topright"
#define GALA_HOT_CORNER_POSITION_BOTTOM_LEFT "hotcorner-bottomleft"
#define GALA_HOT_CORNER_POSITION_BOTTOM_RIGHT "hotcorner-bottomright"
#define GALA_HOT_CORNER_BARRIER_SIZE 30
#define GALA_HOT_CORNER_TRIGGER_PRESSURE_THRESHOLD 50
#define GALA_HOT_CORNER_RELEASE_PRESSURE_THRESHOLD 100
#define GALA_HOT_CORNER_RETRIGGER_PRESSURE_THRESHOLD 500
#define GALA_HOT_CORNER_RETRIGGER_DELAY 600
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_BARRIER (gala_barrier_get_type ())
#define GALA_BARRIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BARRIER, GalaBarrier))
#define GALA_BARRIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BARRIER, GalaBarrierClass))
#define GALA_IS_BARRIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BARRIER))
#define GALA_IS_BARRIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BARRIER))
#define GALA_BARRIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BARRIER, GalaBarrierClass))

typedef struct _GalaBarrier GalaBarrier;
typedef struct _GalaBarrierClass GalaBarrierClass;
typedef struct _GalaBarrierPrivate GalaBarrierPrivate;
enum  {
	GALA_BARRIER_0_PROPERTY,
	GALA_BARRIER_IS_HIT_PROPERTY,
	GALA_BARRIER_PRESSURE_X_PROPERTY,
	GALA_BARRIER_PRESSURE_Y_PROPERTY,
	GALA_BARRIER_NUM_PROPERTIES
};
static GParamSpec* gala_barrier_properties[GALA_BARRIER_NUM_PROPERTIES];

#define GALA_TYPE_HOT_CORNER (gala_hot_corner_get_type ())
#define GALA_HOT_CORNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_HOT_CORNER, GalaHotCorner))
#define GALA_HOT_CORNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_HOT_CORNER, GalaHotCornerClass))
#define GALA_IS_HOT_CORNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_HOT_CORNER))
#define GALA_IS_HOT_CORNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_HOT_CORNER))
#define GALA_HOT_CORNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_HOT_CORNER, GalaHotCornerClass))

typedef struct _GalaHotCorner GalaHotCorner;
typedef struct _GalaHotCornerClass GalaHotCornerClass;
typedef struct _GalaHotCornerPrivate GalaHotCornerPrivate;
enum  {
	GALA_HOT_CORNER_0_PROPERTY,
	GALA_HOT_CORNER_NUM_PROPERTIES
};
static GParamSpec* gala_hot_corner_properties[GALA_HOT_CORNER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_HOT_CORNER_TRIGGER_SIGNAL,
	GALA_HOT_CORNER_NUM_SIGNALS
};
static guint gala_hot_corner_signals[GALA_HOT_CORNER_NUM_SIGNALS] = {0};

struct _GalaBarrier {
	MetaBarrier parent_instance;
	GalaBarrierPrivate * priv;
};

struct _GalaBarrierClass {
	MetaBarrierClass parent_class;
};

struct _GalaBarrierPrivate {
	gboolean _is_hit;
	gdouble _pressure_x;
	gdouble _pressure_y;
};

struct _GalaHotCorner {
	GObject parent_instance;
	GalaHotCornerPrivate * priv;
};

struct _GalaHotCornerClass {
	GObjectClass parent_class;
};

struct _GalaHotCornerPrivate {
	GalaBarrier* vertical_barrier;
	GalaBarrier* horizontal_barrier;
	gboolean triggered;
	guint32 triggered_time;
};

static gint GalaBarrier_private_offset;
static gpointer gala_barrier_parent_class = NULL;
static gint GalaHotCorner_private_offset;
static gpointer gala_hot_corner_parent_class = NULL;

 G_GNUC_INTERNAL GType gala_barrier_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBarrier, g_object_unref)
 G_GNUC_INTERNAL GalaBarrier* gala_barrier_new (MetaDisplay* display,
                               gint x1,
                               gint y1,
                               gint x2,
                               gint y2,
                               MetaBarrierDirection directions);
 G_GNUC_INTERNAL GalaBarrier* gala_barrier_construct (GType object_type,
                                     MetaDisplay* display,
                                     gint x1,
                                     gint y1,
                                     gint x2,
                                     gint y2,
                                     MetaBarrierDirection directions);
 G_GNUC_INTERNAL gboolean gala_barrier_get_is_hit (GalaBarrier* self);
 G_GNUC_INTERNAL void gala_barrier_set_is_hit (GalaBarrier* self,
                              gboolean value);
 G_GNUC_INTERNAL gdouble gala_barrier_get_pressure_x (GalaBarrier* self);
 G_GNUC_INTERNAL void gala_barrier_set_pressure_x (GalaBarrier* self,
                                  gdouble value);
 G_GNUC_INTERNAL gdouble gala_barrier_get_pressure_y (GalaBarrier* self);
 G_GNUC_INTERNAL void gala_barrier_set_pressure_y (GalaBarrier* self,
                                  gdouble value);
static void gala_barrier_finalize (GObject * obj);
static GType gala_barrier_get_type_once (void);
static void _vala_gala_barrier_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_gala_barrier_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
VALA_EXTERN GType gala_hot_corner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaHotCorner, g_object_unref)
VALA_EXTERN GalaHotCorner* gala_hot_corner_new (MetaDisplay* display,
                                    gfloat x,
                                    gfloat y,
                                    gfloat scale,
                                    const gchar* hot_corner_position);
VALA_EXTERN GalaHotCorner* gala_hot_corner_construct (GType object_type,
                                          MetaDisplay* display,
                                          gfloat x,
                                          gfloat y,
                                          gfloat scale,
                                          const gchar* hot_corner_position);
static void gala_hot_corner_add_barriers (GalaHotCorner* self,
                                   MetaDisplay* display,
                                   gfloat x,
                                   gfloat y,
                                   gfloat scale,
                                   const gchar* hot_corner_position);
VALA_EXTERN void gala_hot_corner_destroy_barriers (GalaHotCorner* self);
static void gala_hot_corner_get_barrier_rect (gfloat x,
                                       gfloat y,
                                       gfloat scale,
                                       const gchar* hot_corner_position,
                                       ClutterOrientation orientation,
                                       MtkRectangle* result);
static MetaBarrierDirection gala_hot_corner_get_barrier_direction (const gchar* hot_corner_position,
                                                            ClutterOrientation orientation);
static void __lambda88_ (GalaHotCorner* self,
                  MetaBarrierEvent* event);
static void gala_hot_corner_on_barrier_hit (GalaHotCorner* self,
                                     GalaBarrier* barrier,
                                     MetaBarrierEvent* event);
static void ___lambda88__meta_barrier_hit (MetaBarrier* _sender,
                                    MetaBarrierEvent* event,
                                    gpointer self);
static void __lambda89_ (GalaHotCorner* self,
                  MetaBarrierEvent* event);
static void ___lambda89__meta_barrier_hit (MetaBarrier* _sender,
                                    MetaBarrierEvent* event,
                                    gpointer self);
static void __lambda90_ (GalaHotCorner* self,
                  MetaBarrierEvent* event);
static void gala_hot_corner_on_barrier_left (GalaHotCorner* self,
                                      GalaBarrier* barrier,
                                      MetaBarrierEvent* event);
static void ___lambda90__meta_barrier_left (MetaBarrier* _sender,
                                     MetaBarrierEvent* event,
                                     gpointer self);
static void __lambda91_ (GalaHotCorner* self,
                  MetaBarrierEvent* event);
static void ___lambda91__meta_barrier_left (MetaBarrier* _sender,
                                     MetaBarrierEvent* event,
                                     gpointer self);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_hot_corner_trigger_hot_corner (GalaHotCorner* self);
static void gala_hot_corner_finalize (GObject * obj);
static GType gala_hot_corner_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_barrier_get_instance_private (GalaBarrier* self)
{
	return G_STRUCT_MEMBER_P (self, GalaBarrier_private_offset);
}

 G_GNUC_INTERNAL GalaBarrier*
gala_barrier_construct (GType object_type,
                        MetaDisplay* display,
                        gint x1,
                        gint y1,
                        gint x2,
                        gint y2,
                        MetaBarrierDirection directions)
{
	GalaBarrier * self = NULL;
#line 26 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 27 "../src/HotCorners/HotCorner.vala"
	self = (GalaBarrier*) g_object_new (object_type, "display", display, "x1", x1, "y1", y1, "x2", x2, "y2", y2, "directions", directions, NULL);
#line 26 "../src/HotCorners/HotCorner.vala"
	return self;
#line 254 "HotCorner.c"
}

 G_GNUC_INTERNAL GalaBarrier*
gala_barrier_new (MetaDisplay* display,
                  gint x1,
                  gint y1,
                  gint x2,
                  gint y2,
                  MetaBarrierDirection directions)
{
#line 26 "../src/HotCorners/HotCorner.vala"
	return gala_barrier_construct (GALA_TYPE_BARRIER, display, x1, y1, x2, y2, directions);
#line 267 "HotCorner.c"
}

 G_GNUC_INTERNAL gboolean
gala_barrier_get_is_hit (GalaBarrier* self)
{
	gboolean result;
#line 22 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/HotCorners/HotCorner.vala"
	result = self->priv->_is_hit;
#line 22 "../src/HotCorners/HotCorner.vala"
	return result;
#line 280 "HotCorner.c"
}

 G_GNUC_INTERNAL void
gala_barrier_set_is_hit (GalaBarrier* self,
                         gboolean value)
{
	gboolean old_value;
#line 22 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/HotCorners/HotCorner.vala"
	old_value = gala_barrier_get_is_hit (self);
#line 22 "../src/HotCorners/HotCorner.vala"
	if (old_value != value) {
#line 22 "../src/HotCorners/HotCorner.vala"
		self->priv->_is_hit = value;
#line 22 "../src/HotCorners/HotCorner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_barrier_properties[GALA_BARRIER_IS_HIT_PROPERTY]);
#line 298 "HotCorner.c"
	}
}

 G_GNUC_INTERNAL gdouble
gala_barrier_get_pressure_x (GalaBarrier* self)
{
	gdouble result;
#line 23 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 23 "../src/HotCorners/HotCorner.vala"
	result = self->priv->_pressure_x;
#line 23 "../src/HotCorners/HotCorner.vala"
	return result;
#line 312 "HotCorner.c"
}

 G_GNUC_INTERNAL void
gala_barrier_set_pressure_x (GalaBarrier* self,
                             gdouble value)
{
	gdouble old_value;
#line 23 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/HotCorners/HotCorner.vala"
	old_value = gala_barrier_get_pressure_x (self);
#line 23 "../src/HotCorners/HotCorner.vala"
	if (old_value != value) {
#line 23 "../src/HotCorners/HotCorner.vala"
		self->priv->_pressure_x = value;
#line 23 "../src/HotCorners/HotCorner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_barrier_properties[GALA_BARRIER_PRESSURE_X_PROPERTY]);
#line 330 "HotCorner.c"
	}
}

 G_GNUC_INTERNAL gdouble
gala_barrier_get_pressure_y (GalaBarrier* self)
{
	gdouble result;
#line 24 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 24 "../src/HotCorners/HotCorner.vala"
	result = self->priv->_pressure_y;
#line 24 "../src/HotCorners/HotCorner.vala"
	return result;
#line 344 "HotCorner.c"
}

 G_GNUC_INTERNAL void
gala_barrier_set_pressure_y (GalaBarrier* self,
                             gdouble value)
{
	gdouble old_value;
#line 24 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/HotCorners/HotCorner.vala"
	old_value = gala_barrier_get_pressure_y (self);
#line 24 "../src/HotCorners/HotCorner.vala"
	if (old_value != value) {
#line 24 "../src/HotCorners/HotCorner.vala"
		self->priv->_pressure_y = value;
#line 24 "../src/HotCorners/HotCorner.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_barrier_properties[GALA_BARRIER_PRESSURE_Y_PROPERTY]);
#line 362 "HotCorner.c"
	}
}

static void
gala_barrier_class_init (GalaBarrierClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/HotCorners/HotCorner.vala"
	gala_barrier_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/HotCorners/HotCorner.vala"
	g_type_class_adjust_private_offset (klass, &GalaBarrier_private_offset);
#line 21 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_barrier_get_property;
#line 21 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_barrier_set_property;
#line 21 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_barrier_finalize;
#line 21 "../src/HotCorners/HotCorner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BARRIER_IS_HIT_PROPERTY, gala_barrier_properties[GALA_BARRIER_IS_HIT_PROPERTY] = g_param_spec_boolean ("is-hit", "is-hit", "is-hit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/HotCorners/HotCorner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BARRIER_PRESSURE_X_PROPERTY, gala_barrier_properties[GALA_BARRIER_PRESSURE_X_PROPERTY] = g_param_spec_double ("pressure-x", "pressure-x", "pressure-x", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/HotCorners/HotCorner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BARRIER_PRESSURE_Y_PROPERTY, gala_barrier_properties[GALA_BARRIER_PRESSURE_Y_PROPERTY] = g_param_spec_double ("pressure-y", "pressure-y", "pressure-y", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 386 "HotCorner.c"
}

static void
gala_barrier_instance_init (GalaBarrier * self,
                            gpointer klass)
{
#line 21 "../src/HotCorners/HotCorner.vala"
	self->priv = gala_barrier_get_instance_private (self);
#line 22 "../src/HotCorners/HotCorner.vala"
	self->priv->_is_hit = FALSE;
#line 23 "../src/HotCorners/HotCorner.vala"
	self->priv->_pressure_x = (gdouble) 0;
#line 24 "../src/HotCorners/HotCorner.vala"
	self->priv->_pressure_y = (gdouble) 0;
#line 401 "HotCorner.c"
}

static void
gala_barrier_finalize (GObject * obj)
{
	GalaBarrier * self;
#line 21 "../src/HotCorners/HotCorner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BARRIER, GalaBarrier);
#line 21 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (gala_barrier_parent_class)->finalize (obj);
#line 412 "HotCorner.c"
}

static GType
gala_barrier_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaBarrierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_barrier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaBarrier), 0, (GInstanceInitFunc) gala_barrier_instance_init, NULL };
	GType gala_barrier_type_id;
	gala_barrier_type_id = g_type_register_static (meta_barrier_get_type (), "GalaBarrier", &g_define_type_info, 0);
	GalaBarrier_private_offset = g_type_add_instance_private (gala_barrier_type_id, sizeof (GalaBarrierPrivate));
	return gala_barrier_type_id;
}

 G_GNUC_INTERNAL GType
gala_barrier_get_type (void)
{
	static volatile gsize gala_barrier_type_id__once = 0;
	if (g_once_init_enter (&gala_barrier_type_id__once)) {
		GType gala_barrier_type_id;
		gala_barrier_type_id = gala_barrier_get_type_once ();
		g_once_init_leave (&gala_barrier_type_id__once, gala_barrier_type_id);
	}
	return gala_barrier_type_id__once;
}

static void
_vala_gala_barrier_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	GalaBarrier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BARRIER, GalaBarrier);
#line 21 "../src/HotCorners/HotCorner.vala"
	switch (property_id) {
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_IS_HIT_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		g_value_set_boolean (value, gala_barrier_get_is_hit (self));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_PRESSURE_X_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		g_value_set_double (value, gala_barrier_get_pressure_x (self));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_PRESSURE_Y_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		g_value_set_double (value, gala_barrier_get_pressure_y (self));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 465 "HotCorner.c"
		default:
#line 21 "../src/HotCorners/HotCorner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 471 "HotCorner.c"
	}
}

static void
_vala_gala_barrier_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	GalaBarrier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BARRIER, GalaBarrier);
#line 21 "../src/HotCorners/HotCorner.vala"
	switch (property_id) {
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_IS_HIT_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		gala_barrier_set_is_hit (self, g_value_get_boolean (value));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_PRESSURE_X_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		gala_barrier_set_pressure_x (self, g_value_get_double (value));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 21 "../src/HotCorners/HotCorner.vala"
		case GALA_BARRIER_PRESSURE_Y_PROPERTY:
#line 21 "../src/HotCorners/HotCorner.vala"
		gala_barrier_set_pressure_y (self, g_value_get_double (value));
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 503 "HotCorner.c"
		default:
#line 21 "../src/HotCorners/HotCorner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/HotCorners/HotCorner.vala"
		break;
#line 509 "HotCorner.c"
	}
}

static inline gpointer
gala_hot_corner_get_instance_private (GalaHotCorner* self)
{
	return G_STRUCT_MEMBER_P (self, GalaHotCorner_private_offset);
}

GalaHotCorner*
gala_hot_corner_construct (GType object_type,
                           MetaDisplay* display,
                           gfloat x,
                           gfloat y,
                           gfloat scale,
                           const gchar* hot_corner_position)
{
	GalaHotCorner * self = NULL;
#line 65 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 65 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (hot_corner_position != NULL, NULL);
#line 65 "../src/HotCorners/HotCorner.vala"
	self = (GalaHotCorner*) g_object_new (object_type, NULL);
#line 66 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_add_barriers (self, display, x, y, scale, hot_corner_position);
#line 65 "../src/HotCorners/HotCorner.vala"
	return self;
#line 538 "HotCorner.c"
}

GalaHotCorner*
gala_hot_corner_new (MetaDisplay* display,
                     gfloat x,
                     gfloat y,
                     gfloat scale,
                     const gchar* hot_corner_position)
{
#line 65 "../src/HotCorners/HotCorner.vala"
	return gala_hot_corner_construct (GALA_TYPE_HOT_CORNER, display, x, y, scale, hot_corner_position);
#line 550 "HotCorner.c"
}

void
gala_hot_corner_destroy_barriers (GalaHotCorner* self)
{
	GalaBarrier* _tmp0_;
	GalaBarrier* _tmp2_;
#line 69 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->vertical_barrier;
#line 70 "../src/HotCorners/HotCorner.vala"
	if (_tmp0_ != NULL) {
#line 564 "HotCorner.c"
		GalaBarrier* _tmp1_;
#line 71 "../src/HotCorners/HotCorner.vala"
		_tmp1_ = self->priv->vertical_barrier;
#line 71 "../src/HotCorners/HotCorner.vala"
		meta_barrier_destroy ((MetaBarrier*) _tmp1_);
#line 570 "HotCorner.c"
	}
#line 74 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = self->priv->horizontal_barrier;
#line 74 "../src/HotCorners/HotCorner.vala"
	if (_tmp2_ != NULL) {
#line 576 "HotCorner.c"
		GalaBarrier* _tmp3_;
#line 75 "../src/HotCorners/HotCorner.vala"
		_tmp3_ = self->priv->horizontal_barrier;
#line 75 "../src/HotCorners/HotCorner.vala"
		meta_barrier_destroy ((MetaBarrier*) _tmp3_);
#line 582 "HotCorner.c"
	}
}

static void
__lambda88_ (GalaHotCorner* self,
             MetaBarrierEvent* event)
{
	GalaBarrier* _tmp0_;
#line 88 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 88 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->vertical_barrier;
#line 88 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_on_barrier_hit (self, _tmp0_, event);
#line 597 "HotCorner.c"
}

static void
___lambda88__meta_barrier_hit (MetaBarrier* _sender,
                               MetaBarrierEvent* event,
                               gpointer self)
{
#line 88 "../src/HotCorners/HotCorner.vala"
	__lambda88_ ((GalaHotCorner*) self, event);
#line 607 "HotCorner.c"
}

static void
__lambda89_ (GalaHotCorner* self,
             MetaBarrierEvent* event)
{
	GalaBarrier* _tmp0_;
#line 89 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 89 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->horizontal_barrier;
#line 89 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_on_barrier_hit (self, _tmp0_, event);
#line 621 "HotCorner.c"
}

static void
___lambda89__meta_barrier_hit (MetaBarrier* _sender,
                               MetaBarrierEvent* event,
                               gpointer self)
{
#line 89 "../src/HotCorners/HotCorner.vala"
	__lambda89_ ((GalaHotCorner*) self, event);
#line 631 "HotCorner.c"
}

static void
__lambda90_ (GalaHotCorner* self,
             MetaBarrierEvent* event)
{
	GalaBarrier* _tmp0_;
#line 91 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 91 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->vertical_barrier;
#line 91 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_on_barrier_left (self, _tmp0_, event);
#line 645 "HotCorner.c"
}

static void
___lambda90__meta_barrier_left (MetaBarrier* _sender,
                                MetaBarrierEvent* event,
                                gpointer self)
{
#line 91 "../src/HotCorners/HotCorner.vala"
	__lambda90_ ((GalaHotCorner*) self, event);
#line 655 "HotCorner.c"
}

static void
__lambda91_ (GalaHotCorner* self,
             MetaBarrierEvent* event)
{
	GalaBarrier* _tmp0_;
#line 92 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 92 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->horizontal_barrier;
#line 92 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_on_barrier_left (self, _tmp0_, event);
#line 669 "HotCorner.c"
}

static void
___lambda91__meta_barrier_left (MetaBarrier* _sender,
                                MetaBarrierEvent* event,
                                gpointer self)
{
#line 92 "../src/HotCorners/HotCorner.vala"
	__lambda91_ ((GalaHotCorner*) self, event);
#line 679 "HotCorner.c"
}

static void
gala_hot_corner_add_barriers (GalaHotCorner* self,
                              MetaDisplay* display,
                              gfloat x,
                              gfloat y,
                              gfloat scale,
                              const gchar* hot_corner_position)
{
	MtkRectangle vrect = {0};
	MtkRectangle _tmp0_ = {0};
	MtkRectangle hrect = {0};
	MtkRectangle _tmp1_ = {0};
	MetaBarrierDirection vdir = 0U;
	MetaBarrierDirection hdir = 0U;
	MtkRectangle _tmp2_;
	MtkRectangle _tmp3_;
	MtkRectangle _tmp4_;
	MtkRectangle _tmp5_;
	MtkRectangle _tmp6_;
	MtkRectangle _tmp7_;
	GalaBarrier* _tmp8_;
	MtkRectangle _tmp9_;
	MtkRectangle _tmp10_;
	MtkRectangle _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	MtkRectangle _tmp14_;
	GalaBarrier* _tmp15_;
	GalaBarrier* _tmp16_;
	GalaBarrier* _tmp17_;
	GalaBarrier* _tmp18_;
	GalaBarrier* _tmp19_;
#line 79 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (display != NULL);
#line 79 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (hot_corner_position != NULL);
#line 80 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_get_barrier_rect (x, y, scale, hot_corner_position, CLUTTER_ORIENTATION_VERTICAL, &_tmp0_);
#line 80 "../src/HotCorners/HotCorner.vala"
	vrect = _tmp0_;
#line 81 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_get_barrier_rect (x, y, scale, hot_corner_position, CLUTTER_ORIENTATION_HORIZONTAL, &_tmp1_);
#line 81 "../src/HotCorners/HotCorner.vala"
	hrect = _tmp1_;
#line 82 "../src/HotCorners/HotCorner.vala"
	vdir = gala_hot_corner_get_barrier_direction (hot_corner_position, CLUTTER_ORIENTATION_VERTICAL);
#line 83 "../src/HotCorners/HotCorner.vala"
	hdir = gala_hot_corner_get_barrier_direction (hot_corner_position, CLUTTER_ORIENTATION_HORIZONTAL);
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp3_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp4_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp5_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp6_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp7_ = vrect;
#line 85 "../src/HotCorners/HotCorner.vala"
	_tmp8_ = gala_barrier_new (display, _tmp2_.x, _tmp3_.y, _tmp4_.x + _tmp5_.width, _tmp6_.y + _tmp7_.height, vdir);
#line 85 "../src/HotCorners/HotCorner.vala"
	_g_object_unref0 (self->priv->vertical_barrier);
#line 85 "../src/HotCorners/HotCorner.vala"
	self->priv->vertical_barrier = _tmp8_;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp9_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp10_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp11_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp12_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp13_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp14_ = hrect;
#line 86 "../src/HotCorners/HotCorner.vala"
	_tmp15_ = gala_barrier_new (display, _tmp9_.x, _tmp10_.y, _tmp11_.x + _tmp12_.width, _tmp13_.y + _tmp14_.height, hdir);
#line 86 "../src/HotCorners/HotCorner.vala"
	_g_object_unref0 (self->priv->horizontal_barrier);
#line 86 "../src/HotCorners/HotCorner.vala"
	self->priv->horizontal_barrier = _tmp15_;
#line 88 "../src/HotCorners/HotCorner.vala"
	_tmp16_ = self->priv->vertical_barrier;
#line 88 "../src/HotCorners/HotCorner.vala"
	g_signal_connect_object ((MetaBarrier*) _tmp16_, "hit", (GCallback) ___lambda88__meta_barrier_hit, self, 0);
#line 89 "../src/HotCorners/HotCorner.vala"
	_tmp17_ = self->priv->horizontal_barrier;
#line 89 "../src/HotCorners/HotCorner.vala"
	g_signal_connect_object ((MetaBarrier*) _tmp17_, "hit", (GCallback) ___lambda89__meta_barrier_hit, self, 0);
#line 91 "../src/HotCorners/HotCorner.vala"
	_tmp18_ = self->priv->vertical_barrier;
#line 91 "../src/HotCorners/HotCorner.vala"
	g_signal_connect_object ((MetaBarrier*) _tmp18_, "left", (GCallback) ___lambda90__meta_barrier_left, self, 0);
#line 92 "../src/HotCorners/HotCorner.vala"
	_tmp19_ = self->priv->horizontal_barrier;
#line 92 "../src/HotCorners/HotCorner.vala"
	g_signal_connect_object ((MetaBarrier*) _tmp19_, "left", (GCallback) ___lambda91__meta_barrier_left, self, 0);
#line 784 "HotCorner.c"
}

static MetaBarrierDirection
gala_hot_corner_get_barrier_direction (const gchar* hot_corner_position,
                                       ClutterOrientation orientation)
{
	gboolean vert = FALSE;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 97 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label0 = 0;
#line 97 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label1 = 0;
#line 97 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label2 = 0;
#line 800 "HotCorner.c"
	MetaBarrierDirection result;
#line 95 "../src/HotCorners/HotCorner.vala"
	g_return_val_if_fail (hot_corner_position != NULL, 0U);
#line 96 "../src/HotCorners/HotCorner.vala"
	vert = orientation == CLUTTER_ORIENTATION_VERTICAL;
#line 97 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = hot_corner_position;
#line 97 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 97 "../src/HotCorners/HotCorner.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_TOP_LEFT)))) {
#line 97 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 814 "HotCorner.c"
			default:
			{
				MetaBarrierDirection _tmp3_ = 0U;
#line 99 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 99 "../src/HotCorners/HotCorner.vala"
					_tmp3_ = META_BARRIER_DIRECTION_POSITIVE_X;
#line 822 "HotCorner.c"
				} else {
#line 99 "../src/HotCorners/HotCorner.vala"
					_tmp3_ = META_BARRIER_DIRECTION_POSITIVE_Y;
#line 826 "HotCorner.c"
				}
#line 99 "../src/HotCorners/HotCorner.vala"
				result = _tmp3_;
#line 99 "../src/HotCorners/HotCorner.vala"
				return result;
#line 832 "HotCorner.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_TOP_RIGHT)))) {
#line 97 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 838 "HotCorner.c"
			default:
			{
				MetaBarrierDirection _tmp4_ = 0U;
#line 101 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 101 "../src/HotCorners/HotCorner.vala"
					_tmp4_ = META_BARRIER_DIRECTION_NEGATIVE_X;
#line 846 "HotCorner.c"
				} else {
#line 101 "../src/HotCorners/HotCorner.vala"
					_tmp4_ = META_BARRIER_DIRECTION_POSITIVE_Y;
#line 850 "HotCorner.c"
				}
#line 101 "../src/HotCorners/HotCorner.vala"
				result = _tmp4_;
#line 101 "../src/HotCorners/HotCorner.vala"
				return result;
#line 856 "HotCorner.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_BOTTOM_LEFT)))) {
#line 97 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 862 "HotCorner.c"
			default:
			{
				MetaBarrierDirection _tmp5_ = 0U;
#line 103 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 103 "../src/HotCorners/HotCorner.vala"
					_tmp5_ = META_BARRIER_DIRECTION_POSITIVE_X;
#line 870 "HotCorner.c"
				} else {
#line 103 "../src/HotCorners/HotCorner.vala"
					_tmp5_ = META_BARRIER_DIRECTION_NEGATIVE_Y;
#line 874 "HotCorner.c"
				}
#line 103 "../src/HotCorners/HotCorner.vala"
				result = _tmp5_;
#line 103 "../src/HotCorners/HotCorner.vala"
				return result;
#line 880 "HotCorner.c"
			}
		}
	} else {
#line 97 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 886 "HotCorner.c"
			default:
			{
				MetaBarrierDirection _tmp6_ = 0U;
#line 106 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 106 "../src/HotCorners/HotCorner.vala"
					_tmp6_ = META_BARRIER_DIRECTION_NEGATIVE_X;
#line 894 "HotCorner.c"
				} else {
#line 106 "../src/HotCorners/HotCorner.vala"
					_tmp6_ = META_BARRIER_DIRECTION_NEGATIVE_Y;
#line 898 "HotCorner.c"
				}
#line 106 "../src/HotCorners/HotCorner.vala"
				result = _tmp6_;
#line 106 "../src/HotCorners/HotCorner.vala"
				return result;
#line 904 "HotCorner.c"
			}
		}
	}
}

static void
gala_hot_corner_get_barrier_rect (gfloat x,
                                  gfloat y,
                                  gfloat scale,
                                  const gchar* hot_corner_position,
                                  ClutterOrientation orientation,
                                  MtkRectangle* result)
{
	gint barrier_size = 0;
	gint x1 = 0;
	gint y1 = 0;
	gint x2 = 0;
	gint y2 = 0;
	gboolean vert = FALSE;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 123 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label0 = 0;
#line 123 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label1 = 0;
#line 123 "../src/HotCorners/HotCorner.vala"
	static GQuark _tmp1_label2 = 0;
#line 932 "HotCorner.c"
	MtkRectangle _tmp11_ = {0};
#line 111 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (hot_corner_position != NULL);
#line 115 "../src/HotCorners/HotCorner.vala"
	barrier_size = gala_internal_utils_scale_to_int (GALA_HOT_CORNER_BARRIER_SIZE, scale);
#line 117 "../src/HotCorners/HotCorner.vala"
	x1 = (gint) x;
#line 118 "../src/HotCorners/HotCorner.vala"
	y1 = (gint) y;
#line 122 "../src/HotCorners/HotCorner.vala"
	vert = orientation == CLUTTER_ORIENTATION_VERTICAL;
#line 123 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = hot_corner_position;
#line 123 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 123 "../src/HotCorners/HotCorner.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_TOP_LEFT)))) {
#line 123 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 952 "HotCorner.c"
			default:
			{
				gint _tmp3_ = 0;
				gint _tmp4_ = 0;
#line 125 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 125 "../src/HotCorners/HotCorner.vala"
					_tmp3_ = x1;
#line 961 "HotCorner.c"
				} else {
#line 125 "../src/HotCorners/HotCorner.vala"
					_tmp3_ = x1 + barrier_size;
#line 965 "HotCorner.c"
				}
#line 125 "../src/HotCorners/HotCorner.vala"
				x2 = _tmp3_;
#line 126 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 126 "../src/HotCorners/HotCorner.vala"
					_tmp4_ = y1 + barrier_size;
#line 973 "HotCorner.c"
				} else {
#line 126 "../src/HotCorners/HotCorner.vala"
					_tmp4_ = y1;
#line 977 "HotCorner.c"
				}
#line 126 "../src/HotCorners/HotCorner.vala"
				y2 = _tmp4_;
#line 127 "../src/HotCorners/HotCorner.vala"
				break;
#line 983 "HotCorner.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_TOP_RIGHT)))) {
#line 123 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 989 "HotCorner.c"
			default:
			{
				gint _tmp5_ = 0;
				gint _tmp6_ = 0;
#line 129 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 129 "../src/HotCorners/HotCorner.vala"
					_tmp5_ = x1;
#line 998 "HotCorner.c"
				} else {
#line 129 "../src/HotCorners/HotCorner.vala"
					_tmp5_ = x1 - barrier_size;
#line 1002 "HotCorner.c"
				}
#line 129 "../src/HotCorners/HotCorner.vala"
				x2 = _tmp5_;
#line 130 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 130 "../src/HotCorners/HotCorner.vala"
					_tmp6_ = y1 + barrier_size;
#line 1010 "HotCorner.c"
				} else {
#line 130 "../src/HotCorners/HotCorner.vala"
					_tmp6_ = y1;
#line 1014 "HotCorner.c"
				}
#line 130 "../src/HotCorners/HotCorner.vala"
				y2 = _tmp6_;
#line 131 "../src/HotCorners/HotCorner.vala"
				break;
#line 1020 "HotCorner.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string (GALA_HOT_CORNER_POSITION_BOTTOM_LEFT)))) {
#line 123 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 1026 "HotCorner.c"
			default:
			{
				gint _tmp7_ = 0;
				gint _tmp8_ = 0;
#line 133 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 133 "../src/HotCorners/HotCorner.vala"
					_tmp7_ = x1;
#line 1035 "HotCorner.c"
				} else {
#line 133 "../src/HotCorners/HotCorner.vala"
					_tmp7_ = x1 + barrier_size;
#line 1039 "HotCorner.c"
				}
#line 133 "../src/HotCorners/HotCorner.vala"
				x2 = _tmp7_;
#line 134 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 134 "../src/HotCorners/HotCorner.vala"
					_tmp8_ = y1 - barrier_size;
#line 1047 "HotCorner.c"
				} else {
#line 134 "../src/HotCorners/HotCorner.vala"
					_tmp8_ = y1;
#line 1051 "HotCorner.c"
				}
#line 134 "../src/HotCorners/HotCorner.vala"
				y2 = _tmp8_;
#line 135 "../src/HotCorners/HotCorner.vala"
				break;
#line 1057 "HotCorner.c"
			}
		}
	} else {
#line 123 "../src/HotCorners/HotCorner.vala"
		switch (0) {
#line 1063 "HotCorner.c"
			default:
			{
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
#line 138 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 138 "../src/HotCorners/HotCorner.vala"
					_tmp9_ = x1;
#line 1072 "HotCorner.c"
				} else {
#line 138 "../src/HotCorners/HotCorner.vala"
					_tmp9_ = x1 - barrier_size;
#line 1076 "HotCorner.c"
				}
#line 138 "../src/HotCorners/HotCorner.vala"
				x2 = _tmp9_;
#line 139 "../src/HotCorners/HotCorner.vala"
				if (vert) {
#line 139 "../src/HotCorners/HotCorner.vala"
					_tmp10_ = y1 - barrier_size;
#line 1084 "HotCorner.c"
				} else {
#line 139 "../src/HotCorners/HotCorner.vala"
					_tmp10_ = y1;
#line 1088 "HotCorner.c"
				}
#line 139 "../src/HotCorners/HotCorner.vala"
				y2 = _tmp10_;
#line 140 "../src/HotCorners/HotCorner.vala"
				break;
#line 1094 "HotCorner.c"
			}
		}
	}
#line 143 "../src/HotCorners/HotCorner.vala"
	_tmp11_.x = x1;
#line 143 "../src/HotCorners/HotCorner.vala"
	_tmp11_.y = y1;
#line 143 "../src/HotCorners/HotCorner.vala"
	_tmp11_.width = x2 - x1;
#line 143 "../src/HotCorners/HotCorner.vala"
	_tmp11_.height = y2 - y1;
#line 143 "../src/HotCorners/HotCorner.vala"
	*result = _tmp11_;
#line 143 "../src/HotCorners/HotCorner.vala"
	return;
#line 1110 "HotCorner.c"
}

static void
gala_hot_corner_on_barrier_hit (GalaHotCorner* self,
                                GalaBarrier* barrier,
                                MetaBarrierEvent* event)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_ = 0.0;
	GalaBarrier* _tmp5_;
	gdouble pressure = 0.0;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
#line 146 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (barrier != NULL);
#line 146 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 147 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_is_hit (barrier, TRUE);
#line 148 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = gala_barrier_get_pressure_x (barrier);
#line 148 "../src/HotCorners/HotCorner.vala"
	_tmp1_ = _tmp0_;
#line 148 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_x (barrier, _tmp1_ + event->dx);
#line 149 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = gala_barrier_get_pressure_y (barrier);
#line 149 "../src/HotCorners/HotCorner.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_y (barrier, _tmp3_ + event->dy);
#line 151 "../src/HotCorners/HotCorner.vala"
	_tmp5_ = self->priv->vertical_barrier;
#line 151 "../src/HotCorners/HotCorner.vala"
	if (barrier == _tmp5_) {
#line 1154 "HotCorner.c"
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 152 "../src/HotCorners/HotCorner.vala"
		_tmp6_ = gala_barrier_get_pressure_x (barrier);
#line 152 "../src/HotCorners/HotCorner.vala"
		_tmp7_ = _tmp6_;
#line 152 "../src/HotCorners/HotCorner.vala"
		_tmp4_ = fabs (_tmp7_);
#line 1163 "HotCorner.c"
	} else {
		gdouble _tmp8_;
		gdouble _tmp9_;
#line 153 "../src/HotCorners/HotCorner.vala"
		_tmp8_ = gala_barrier_get_pressure_y (barrier);
#line 153 "../src/HotCorners/HotCorner.vala"
		_tmp9_ = _tmp8_;
#line 153 "../src/HotCorners/HotCorner.vala"
		_tmp4_ = fabs (_tmp9_);
#line 1173 "HotCorner.c"
	}
#line 151 "../src/HotCorners/HotCorner.vala"
	pressure = _tmp4_;
#line 155 "../src/HotCorners/HotCorner.vala"
	if (!self->priv->triggered) {
#line 1179 "HotCorner.c"
		GalaBarrier* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp12_ = self->priv->vertical_barrier;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp13_ = gala_barrier_get_is_hit (_tmp12_);
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp14_ = _tmp13_;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp11_ = _tmp14_;
#line 1191 "HotCorner.c"
	} else {
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp11_ = FALSE;
#line 1195 "HotCorner.c"
	}
#line 155 "../src/HotCorners/HotCorner.vala"
	if (_tmp11_) {
#line 1199 "HotCorner.c"
		GalaBarrier* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp15_ = self->priv->horizontal_barrier;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp16_ = gala_barrier_get_is_hit (_tmp15_);
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp17_ = _tmp16_;
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp10_ = _tmp17_;
#line 1211 "HotCorner.c"
	} else {
#line 155 "../src/HotCorners/HotCorner.vala"
		_tmp10_ = FALSE;
#line 1215 "HotCorner.c"
	}
#line 155 "../src/HotCorners/HotCorner.vala"
	if (_tmp10_) {
#line 156 "../src/HotCorners/HotCorner.vala"
		if (fabs (pressure) > ((gdouble) GALA_HOT_CORNER_TRIGGER_PRESSURE_THRESHOLD)) {
#line 157 "../src/HotCorners/HotCorner.vala"
			gala_hot_corner_trigger_hot_corner (self);
#line 158 "../src/HotCorners/HotCorner.vala"
			pressure = (gdouble) 0;
#line 159 "../src/HotCorners/HotCorner.vala"
			self->priv->triggered_time = event->time;
#line 1227 "HotCorner.c"
		}
	}
#line 163 "../src/HotCorners/HotCorner.vala"
	if (!self->priv->triggered) {
#line 163 "../src/HotCorners/HotCorner.vala"
		_tmp18_ = fabs (pressure) > ((gdouble) GALA_HOT_CORNER_RELEASE_PRESSURE_THRESHOLD);
#line 1234 "HotCorner.c"
	} else {
#line 163 "../src/HotCorners/HotCorner.vala"
		_tmp18_ = FALSE;
#line 1238 "HotCorner.c"
	}
#line 163 "../src/HotCorners/HotCorner.vala"
	if (_tmp18_) {
#line 164 "../src/HotCorners/HotCorner.vala"
		meta_barrier_release ((MetaBarrier*) barrier, event);
#line 1244 "HotCorner.c"
	}
#line 167 "../src/HotCorners/HotCorner.vala"
	if (self->priv->triggered) {
#line 167 "../src/HotCorners/HotCorner.vala"
		_tmp20_ = fabs (pressure) > ((gdouble) GALA_HOT_CORNER_RETRIGGER_PRESSURE_THRESHOLD);
#line 1250 "HotCorner.c"
	} else {
#line 167 "../src/HotCorners/HotCorner.vala"
		_tmp20_ = FALSE;
#line 1254 "HotCorner.c"
	}
#line 167 "../src/HotCorners/HotCorner.vala"
	if (_tmp20_) {
#line 167 "../src/HotCorners/HotCorner.vala"
		_tmp19_ = event->time > (GALA_HOT_CORNER_RETRIGGER_DELAY + self->priv->triggered_time);
#line 1260 "HotCorner.c"
	} else {
#line 167 "../src/HotCorners/HotCorner.vala"
		_tmp19_ = FALSE;
#line 1264 "HotCorner.c"
	}
#line 167 "../src/HotCorners/HotCorner.vala"
	if (_tmp19_) {
#line 168 "../src/HotCorners/HotCorner.vala"
		gala_hot_corner_trigger_hot_corner (self);
#line 1270 "HotCorner.c"
	}
}

static void
gala_hot_corner_on_barrier_left (GalaHotCorner* self,
                                 GalaBarrier* barrier,
                                 MetaBarrierEvent* event)
{
	gboolean _tmp0_ = FALSE;
	GalaBarrier* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 172 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (barrier != NULL);
#line 172 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (event != NULL);
#line 173 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_is_hit (barrier, FALSE);
#line 174 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_x (barrier, (gdouble) 0);
#line 175 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_y (barrier, (gdouble) 0);
#line 177 "../src/HotCorners/HotCorner.vala"
	_tmp1_ = self->priv->vertical_barrier;
#line 177 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = gala_barrier_get_is_hit (_tmp1_);
#line 177 "../src/HotCorners/HotCorner.vala"
	_tmp3_ = _tmp2_;
#line 177 "../src/HotCorners/HotCorner.vala"
	if (!_tmp3_) {
#line 1303 "HotCorner.c"
		GalaBarrier* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 177 "../src/HotCorners/HotCorner.vala"
		_tmp4_ = self->priv->horizontal_barrier;
#line 177 "../src/HotCorners/HotCorner.vala"
		_tmp5_ = gala_barrier_get_is_hit (_tmp4_);
#line 177 "../src/HotCorners/HotCorner.vala"
		_tmp6_ = _tmp5_;
#line 177 "../src/HotCorners/HotCorner.vala"
		_tmp0_ = !_tmp6_;
#line 1315 "HotCorner.c"
	} else {
#line 177 "../src/HotCorners/HotCorner.vala"
		_tmp0_ = FALSE;
#line 1319 "HotCorner.c"
	}
#line 177 "../src/HotCorners/HotCorner.vala"
	if (_tmp0_) {
#line 178 "../src/HotCorners/HotCorner.vala"
		self->priv->triggered = FALSE;
#line 1325 "HotCorner.c"
	}
}

static void
gala_hot_corner_trigger_hot_corner (GalaHotCorner* self)
{
	GalaBarrier* _tmp0_;
	GalaBarrier* _tmp1_;
	GalaBarrier* _tmp2_;
	GalaBarrier* _tmp3_;
#line 182 "../src/HotCorners/HotCorner.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/HotCorners/HotCorner.vala"
	self->priv->triggered = TRUE;
#line 184 "../src/HotCorners/HotCorner.vala"
	_tmp0_ = self->priv->vertical_barrier;
#line 184 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_x (_tmp0_, (gdouble) 0);
#line 185 "../src/HotCorners/HotCorner.vala"
	_tmp1_ = self->priv->vertical_barrier;
#line 185 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_y (_tmp1_, (gdouble) 0);
#line 186 "../src/HotCorners/HotCorner.vala"
	_tmp2_ = self->priv->horizontal_barrier;
#line 186 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_x (_tmp2_, (gdouble) 0);
#line 187 "../src/HotCorners/HotCorner.vala"
	_tmp3_ = self->priv->horizontal_barrier;
#line 187 "../src/HotCorners/HotCorner.vala"
	gala_barrier_set_pressure_y (_tmp3_, (gdouble) 0);
#line 188 "../src/HotCorners/HotCorner.vala"
	g_signal_emit (self, gala_hot_corner_signals[GALA_HOT_CORNER_TRIGGER_SIGNAL], 0);
#line 1358 "HotCorner.c"
}

static void
gala_hot_corner_class_init (GalaHotCornerClass * klass,
                            gpointer klass_data)
{
#line 31 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/HotCorners/HotCorner.vala"
	g_type_class_adjust_private_offset (klass, &GalaHotCorner_private_offset);
#line 31 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_hot_corner_finalize;
#line 31 "../src/HotCorners/HotCorner.vala"
	gala_hot_corner_signals[GALA_HOT_CORNER_TRIGGER_SIGNAL] = g_signal_new ("trigger", GALA_TYPE_HOT_CORNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1373 "HotCorner.c"
}

static void
gala_hot_corner_instance_init (GalaHotCorner * self,
                               gpointer klass)
{
#line 31 "../src/HotCorners/HotCorner.vala"
	self->priv = gala_hot_corner_get_instance_private (self);
#line 60 "../src/HotCorners/HotCorner.vala"
	self->priv->vertical_barrier = NULL;
#line 61 "../src/HotCorners/HotCorner.vala"
	self->priv->horizontal_barrier = NULL;
#line 62 "../src/HotCorners/HotCorner.vala"
	self->priv->triggered = FALSE;
#line 1388 "HotCorner.c"
}

static void
gala_hot_corner_finalize (GObject * obj)
{
	GalaHotCorner * self;
#line 31 "../src/HotCorners/HotCorner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_HOT_CORNER, GalaHotCorner);
#line 60 "../src/HotCorners/HotCorner.vala"
	_g_object_unref0 (self->priv->vertical_barrier);
#line 61 "../src/HotCorners/HotCorner.vala"
	_g_object_unref0 (self->priv->horizontal_barrier);
#line 31 "../src/HotCorners/HotCorner.vala"
	G_OBJECT_CLASS (gala_hot_corner_parent_class)->finalize (obj);
#line 1403 "HotCorner.c"
}

static GType
gala_hot_corner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaHotCornerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_hot_corner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaHotCorner), 0, (GInstanceInitFunc) gala_hot_corner_instance_init, NULL };
	GType gala_hot_corner_type_id;
	gala_hot_corner_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaHotCorner", &g_define_type_info, 0);
	GalaHotCorner_private_offset = g_type_add_instance_private (gala_hot_corner_type_id, sizeof (GalaHotCornerPrivate));
	return gala_hot_corner_type_id;
}

GType
gala_hot_corner_get_type (void)
{
	static volatile gsize gala_hot_corner_type_id__once = 0;
	if (g_once_init_enter (&gala_hot_corner_type_id__once)) {
		GType gala_hot_corner_type_id;
		gala_hot_corner_type_id = gala_hot_corner_get_type_once ();
		g_once_init_leave (&gala_hot_corner_type_id__once, gala_hot_corner_type_id);
	}
	return gala_hot_corner_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1439 "HotCorner.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 1443 "HotCorner.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 1447 "HotCorner.c"
}

